modimport"scripts/bs_init/Juren_gooddata.lua"
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local STRINGS = GLOBAL.STRINGS
local IsServer = GLOBAL.TheNet:GetIsServer()
local Vector3 = GLOBAL.Vector3
local TUNING = GLOBAL.TUNING
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local SpawnPrefab = GLOBAL.SpawnPrefab
local TheWorld=GLOBAL.TheWorld
local TheNet= GLOBAL.TheNet

local require=GLOBAL.require
local containers = require "containers"
PrefabFiles = {
	"skw_builder",
	"skw_dog",
	"skw_dmound",
	"skw_trap",
	"skeleton",
	"skwcoin",
}
Assets = {
	Asset("ATLAS", "images/background/skwbackground.xml"),
	Asset("IMAGE", "images/background/skwbackground.tex"),
	Asset("ATLAS", "images/hud/next_page.xml"),
	Asset("IMAGE", "images/hud/next_page.tex"),
	Asset("ATLAS", "images/hud/last_page.xml"),
	Asset("IMAGE", "images/hud/last_page.tex"),
	Asset("ATLAS", "images/hud/shutdown.xml"),
	Asset("IMAGE", "images/hud/shutdown.tex"),
	Asset("ATLAS", "images/inventoryimages/skwcoin.xml"),
    Asset("IMAGE", "images/inventoryimages/skwcoin.tex"),
 }
local coin_item=GetModConfigData("coin")
TUNING.skw_number= GetModConfigData("skw_number")  
TUNING.skw_player= GetModConfigData("skw_player")  
TUNING.have_heart= GetModConfigData("have_heart")  
TUNING.skw_tradelevel= GetModConfigData("skw_tradelevel")  
 

if  TUNING.have_heart then
	AddRecipe("shadowheart",{Ingredient("nightmarefuel", 40)},RECIPETABS.REFINE,TECH.SCIENCE_ONE, nil, nil, nil,nil, nil)
end 
local function ondeploy(inst, pt) 
    local treestand = SpawnPrefab("winter_treestand")
    if treestand then
		treestand.Transform:SetPosition(pt.x, pt.y, pt.z)
		inst:Remove()
    end
end
AddPrefabPostInit("teleportato_potato",function(inst)
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = ondeploy
end)


goodsrandom={}
AddPrefabPostInit("world",function(inst)
	inst:WatchWorldState("phase", function(inst, phase)
		if phase=="day"	then
			local num=#juren_goodsinfo
			for i=1,29 do
				local x=math.random(1,math.ceil(#juren_goodsinfo/30))+(i-1)*5
				goodsrandom[i]=juren_goodsinfo[x]
				goodsrandom[i][1]=juren_goodsinfo[x][1]
				goodsrandom[i][2]=juren_goodsinfo[x][2]
				goodsrandom[i][3]=juren_goodsinfo[x][3]
			end
			local y=30*math.ceil(#juren_goodsinfo/30)-5+math.random(1,#juren_goodsinfo-29*math.ceil(#juren_goodsinfo/30))
			goodsrandom[30]=juren_goodsinfo[y]
			goodsrandom[30][1]=juren_goodsinfo[y][1]
			goodsrandom[30][2]=juren_goodsinfo[y][2]
			goodsrandom[30][3]=juren_goodsinfo[y][3]
		end
	end)
	inst:DoTaskInTime(2,function()
		if #goodsrandom==0 then
			local num=#juren_goodsinfo
			for i=1,29 do
				local x=math.random(1,math.ceil(#juren_goodsinfo/30))+(i-1)*5
				goodsrandom[i]=juren_goodsinfo[x]
				goodsrandom[i][1]=juren_goodsinfo[x][1]
				goodsrandom[i][2]=juren_goodsinfo[x][2]
				goodsrandom[i][3]=juren_goodsinfo[x][3]
			end
			local y=30*math.ceil(#juren_goodsinfo/30)-5+math.random(1,#juren_goodsinfo-29*math.ceil(#juren_goodsinfo/30))
			goodsrandom[30]=juren_goodsinfo[y]
			goodsrandom[30][1]=juren_goodsinfo[y][1]
			goodsrandom[30][2]=juren_goodsinfo[y][2]
			goodsrandom[30][3]=juren_goodsinfo[y][3]
		end
	end)
end)







AddPrefabPostInit("skw_builder", function (inst)
	inst:ListenForEvent("onremove", function()
		if 	inst.components.skw_stages and inst.components.skw_stages.current>=59 then
			local lastattacker = inst.components.combat and inst.components.combat.lastattacker
			local dpt=inst.components.knownlocations:GetLocation("home") 
			local teleportato_base=SpawnPrefab("teleportato_base")
				TheNet:Announce("〖 "..inst:GetDisplayName().." 〗".. (lastattacker and "被〖 "..lastattacker.name.." 〗击杀" or "") .."将在3天后刷新")	
				teleportato_base.Transform:SetPosition(dpt.x,0,dpt.z)
				if inst.leader then
					teleportato_base.leader=inst.leader
					--print("主人："..teleportato_base.leader)
				end
				teleportato_base.leaderid=inst.leaderid or nil
		end
	end)
end)
local function onsave(inst, data)
	data.leader=inst.leader or nil
	data.leaderid=inst.leaderid or nil
end

local function onpreload(inst, data)
	if data  then

		inst.leader=data.leader
		inst.leaderid=data.leaderid
	end
end
AddPrefabPostInit("teleportato_base", function (inst)
	inst:AddTag("skw")
	inst:AddComponent("age")
	inst.onpreload = onpreload
	inst.OnSave = onsave
	inst:DoPeriodicTask(30 ,function(inst)
		if inst.components.age:GetAge()>=480*3 then
			local skw_builder=SpawnPrefab("skw_builder")
			local x,y,z=inst.Transform:GetWorldPosition()			
			inst:Remove()
			skw_builder.Transform:SetPosition(x,y,z)
			inst:DoTaskInTime(1,function()
				if skw_builder.components.skw_stages then
				skw_builder.components.skw_stages.current=60
				end
			end)
			if inst.leader then
				--TheNet:Announce(inst.leader.."的活骷髅已复活！！")
				skw_builder.leader=inst.leader
				--print("主人："..inst.leader)
			end
			skw_builder.leaderid=inst.leaderid

		end	
	end)
end)











TUNING.DES_DIALOG = "Dialog"
TUNING.DES_DIALOG_TEXT = "Dialog"





STRINGS.NAMES.SKW_TRAP = "骷髅陷阱"

STRINGS.NAMES.SKWCOIN = "骷髅金币"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKWCOIN ="用于和骷髅交易"
-----------=====================================================-----------
-----------=====================================================-----------
-----------===================  SKELETON QUOTES ==================-----------===================
STRINGS.NAMES.SKW_DMOUND = "Dog's house"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DMOUND = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DMOUND.GENERIC = "Evil dogs live here."
STRINGS.NAMES.SKW_DOG = "Dog"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOG = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOG.GENERIC = "It's someone's dog!"
STRINGS.NAMES.SKW_DOGFIRE = "Red Dog"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOGFIRE = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOGFIRE.GENERIC = "This dog looks hot."
STRINGS.NAMES.SKW_DOGICE = "Blue Dog"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOGICE = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DOGICE.GENERIC = "This dog looks cold."



STRINGS.S_CHAR_TALK_HELLO = {"Hello! I am Wilson...","Uh, hi! My name is Willow, I stuck here..."}

STRINGS.SKW_TALK_FOOD = {"My bones are hungry.","Bones are rattling.","Time for a break.","Time for a dinner!","Time for a breakfast!"}

STRINGS.S_CHAR_TALK_LETSLIVE = {"I think it is easier to burn things together!"}



STRINGS.SKW_TALK_RIZE = {"Another time I am here.",
"I thought I am dead.","Uh, am I still alive?","I've so much to do...",
"Maxwell, I take revanche!","Maxwell, you won't breal me this time!",
"Maxwell, I've got another attemp!","Not dead, yet!"}

STRINGS.SKW_TALK_DEATH = {"I thought... I was alife.","Dead... Again?", "No! I've so much left to do...",
"Maxwell always wins...","Maxwell won...","You are we next.",
"Second chance, lost...","I fall into the shade.","To the dust return.","Darkness takes me...","Not dead... yet..."}

STRINGS.SKW_TALK_TRADE = {"Nice trade.","Good exchange.","Next time bring something more useful."}


STRINGS.SKW_TALK_RUNAWAY_WILSON = {"Get away!","Rattle.","Shhhh","I've so much to do.","Meet you in grave...","Bring me some stuff."}
STRINGS.SKW_TALK_HELP_CHOP_WOOD = {"For the ashesssss!", "Go into my backpack!", "I need more wooood..."}
STRINGS.SKW_TALK_PANICFIRE = { "Fire isn't hot!", "Into ashess...", "It burns!", "My blood runs cold...","Shhhhh" }
STRINGS.SKW_TALK_FIND_LIGHT = {"Sssscary", "So cold...", "Need suuuuun...", "Need fire", "Can't see..."}
STRINGS.SKW_TALK_OTHER = {
			"Ehhhhhhhhhhhhhh.",
			"Eeeeeeeeeeeer.",
			"Rattle.",
			"click click click click",
			"Hissss!",
			"Aaaaaaaaa.",
			"mooooooooooooaaaaan.",	} 


STRINGS.SKW_TALK_FIGHT = {
			"Ehhhhhhhhhhhhhh.",
			"Eeeeeeeeeeeer.",
			"Rattle.",
			"click click click click",
			"Hissss!",
			"Aaaaaaaaa.",
			"mooooooooooooaaaaan.",	} 
STRINGS.SKW_TALK_FOLLOWWILSON= "test"

STRINGS.NAMES.SKW_AXEFARMER = "Farmer"
STRINGS.NAMES.SKW_DART = "Skeleton"
STRINGS.NAMES.SKW_MAGE = "Skeleton"
STRINGS.NAMES.SKW_WAR = "Marauder"
STRINGS.NAMES.SKW_CANE = "Gentleman"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_AXEFARMER = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_AXEFARMER.GENERIC = "Give me some honey, please."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DART = {}

STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_DART.GENERIC = "His hunt will never end..."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_MAGE = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_MAGE.GENERIC = "He rised with power of science."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_WAR = {}

STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_WAR.GENERIC = "Do not touch my stuff."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_CANE = {}

STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKW_CANE.GENERIC = "Is this my future?"


STRINGS.CHARACTERS.WX78.DESCRIBE.SKW = "HUMAN INSIDES"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.SKW = "It smells strange."
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.SKW = "A fine specimen."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.SKW = "Bone man."
STRINGS.CHARACTERS.WENDY.DESCRIBE.SKW = "I wish my sister was as solid as this..."
STRINGS.CHARACTERS.SKW = {}
STRINGS.CHARACTERS.SKW.COMBAT_QUIT={
	GENERIC = " ",
}



----------------------------------------------------------------------------------------------------
--[API]AddAction(id, str, fn)
----------------------------------------------------------------------------------------------------



AddAction("SKWOPEN", "open", function(act)
    if act.target.components.skwshop == nil then return false end
    
    if act.target.components.skwshop:CanOpen(act.doer) then
        act.target.components.skwshop:OpenStore(act.doer)
    end
    act.doer._isopening:set(true)
	act.doer._isopening:set_local(true)
	act.target.SKW_Send:push()
	if act.target.sg then
		act.target.sg:GoToState("shopping")
	end
    return true
end)
AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(GLOBAL.ACTIONS.SKWOPEN, "doshortaction"))
AddStategraphActionHandler("wilson_client", GLOBAL.ActionHandler(GLOBAL.ACTIONS.SKWOPEN, "doshortaction"))

----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
AddComponentAction("SCENE", "skwshop", function(inst, doer, actions)
    table.insert(actions, GLOBAL.ACTIONS.SKWOPEN)
end)

----------------------------------------------------------------------------------------------------
AddPlayerPostInit(function(inst)
    inst._isopening = GLOBAL.net_bool(inst.GUID, "IsOpening", "Store_IsOpening")
end)

----------------------------------------------------------------------------------------------------

local function SendPurFunction(inst)
	inst:DoTaskInTime(0.2,function()
		if GLOBAL.ThePlayer and GLOBAL.ThePlayer._isopening and not GLOBAL.ThePlayer._isopening:value() then return false end
		local topscreen = GLOBAL.TheFrontEnd:GetActiveScreen()
		if  topscreen and topscreen.name~="Skw_store" and GLOBAL.TheFrontEnd:GetScreenStackSize()<=1 then
			local skw_store = require("screens/skw_store")
			GLOBAL.TheFrontEnd:PushScreen(skw_store(GLOBAL.ThePlayer,inst,goodsrandom))
		end
	end)
	--[[inst:DoTaskInTime(0.5,function()
		local topscreen2 = GLOBAL.TheFrontEnd:GetActiveScreen()
		if topscreen2.name=="Skw_store" and GLOBAL.TheFrontEnd:GetScreenStackSize()>=0 then
			topscreen2:CreatAmount(goodsrandom)
		end
	end)--]]
end
local function ShutStoreFunction(inst)
--inst:DoTaskInTime(0.1, function()print(GLOBAL.ThePlayer._isopening:value()) end)
end
AddPrefabPostInit("skw_builder", function(inst)

    inst.SKW_Send  = GLOBAL.net_event(inst.GUID, "NetEvt_SKW_Send")
	inst.SKW_ShutStore = GLOBAL.net_event(inst.GUID, "NetEvt_SKW_ShutStore")
    inst.SendPur = SendPurFunction
	inst.ShutStore = ShutStoreFunction
    --- 独立服务器 并且 不是客户端 的情况下,不需要监听事件
    if GLOBAL.TheNet:IsDedicated() and not GLOBAL.TheNet:GetIsClient() then return end
    inst:ListenForEvent("NetEvt_SKW_Send", inst.SendPur, inst)
	inst:ListenForEvent("NetEvt_SKW_ShutStore", inst.ShutStore, inst)

end)

if GLOBAL.TheNet:GetIsClient() then AddModRPCHandler("Skw_store", "ShutStore", function() end) end

local function ClientShutStore(player, inst)
    player._isopening:set(false)
    inst.SKW_ShutStore:push()
end
if not GLOBAL.TheNet:GetIsClient() and not GLOBAL.MOD_RPC_HANDLERS["Skw_store"] then
    AddModRPCHandler("Skw_store", "ShutStore", ClientShutStore)
end

local function mybuy(player,name,price)
    if not player.components then  player:RemoveTag("skwtrade") return false end
    if not player.components.inventory then  player:RemoveTag("skwtrade")  return false end
		--if  goodsrandom[num][3]>=1 then
			if not player.components.inventory:Has(coin_item,price) then player:RemoveTag("skwtrade")  return false end
			player:AddTag("skwtrade")
			player.components.inventory:ConsumeByName(coin_item,price )
			
			--goodsrandom[num][3]=goodsrandom[num][3]-1
				
			--print(goodsrandom[num][1]..":"..goodsrandom[num][2])
			player.components.inventory:GiveItem(SpawnPrefab(name))
			
		--end

end
if not GLOBAL.TheNet:GetIsClient()  then
	AddModRPCHandler("Skw_store", "buy",mybuy)
else
	AddModRPCHandler("Skw_store", "buy", function() end)
end
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------


--[[local skw_opener = 0

for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
    if GLOBAL.KnownModIndex:GetModInfo(moddir).name == " 河蟹防熊锁" then
		skw_opener = 1
   end 
end --]]
local _G = GLOBAL
local TheSim = _G.TheSim
local IsServer = TheNet:GetIsServer() or TheNet:IsDedicated()
if IsServer --[[and skw_opener == 1--]] then



	--[[local function CheckFriend00(masterId, guestId)

		if masterId == nil or guestId == nil then return false end

		return _G.TheWorld.guard_authorization ~= nil and _G.TheWorld.guard_authorization[masterId] ~= nil and _G.TheWorld.guard_authorization[masterId].friends and _G.TheWorld.guard_authorization[masterId].friends[guestId]
	end--]]

	local old_SKWOPEN = _G.ACTIONS.SKWOPEN.fn 
	_G.ACTIONS.SKWOPEN.fn = function(act)
		if act.doer and act.target and act.target.prefab == "skw_builder" then
			if act.target.components.skw_stages and act.target.components.skw_stages.current< TUNING.skw_tradelevel then
				act.doer:DoTaskInTime(0.01,function()
					act.doer.components.talker:Say("该骷髅目前等级为 "..act.target.components.skw_stages.current..",需要".. TUNING.skw_tradelevel.."级才具有商店功能!")
				end)
				return false
			end
			if _G.TheWorld.state.isnight	then
				act.doer:DoTaskInTime(0.01,function()
					act.doer.components.talker:Say("夜晚不能购买物品！")
				end)
				return false
			end
			--[[if act.target == nil or act.target.ownerlist== nil then

				return old_SKWOPEN(act)
			elseif act.target ~=nil and act.target.ownerlist ~= nil 
				and (act.target.ownerlist.master==act.doer.userid or CheckFriend00(act.target.ownerlist.master,act.doer.userid)) then

				return old_SKWOPEN(act)
				end--]]
			end
			--[[act.doer:DoTaskInTime(0.01,function()
				act.doer.components.talker:Say("没有权限使用该骷髅！")
			end)
			return false--]]
			return old_SKWOPEN(act)
		end

end
local function spawnchest(inst,num)
	local x, y, z = inst.Transform:GetWorldPosition()
	local bundle = SpawnPrefab("gift")
	local coin = {SpawnPrefab("skwcoin"),}
	coin[1].components.stackable.stacksize = num
	bundle.components.unwrappable:WrapItems(coin)
	for i, v in ipairs(coin) do
        v:Remove()
    end
    inst.components.lootdropper:FlingItem(bundle)
	--inst.components.inventory:DropItem()--c_spawn("dragonfly")
	--[[local coin = SpawnPrefab("skwcoin")
	coin.components.stackable:SetStackSize(num)
	chest.components.container:GiveItem(coin)
	chest:DoTaskInTime(30,function(inst)
		inst.components.container:DropEverything()
		inst:Remove()
	end)--]]
end
local function death(inst, data)
	if   inst.components.health then
		if	inst.components.health.maxhealth then
			if	inst.components.health.maxhealth>=100 and inst.components.health.maxhealth<=200 then
				inst.components.lootdropper:AddChanceLoot("skwcoin", 0.1)
			end
			if	inst.components.health.maxhealth>200 and inst.components.health.maxhealth<=500 then
				inst.components.lootdropper:AddChanceLoot("skwcoin", 0.3)
			end
			if	inst.components.health.maxhealth>500 and inst.components.health.maxhealth<=1000 then
				for i=1,2 do
					inst.components.lootdropper:AddChanceLoot("skwcoin", 0.8)
				end
			end
			if	inst.components.health.maxhealth>1000 and inst.components.health.maxhealth<=3000 then
				spawnchest(inst,5)
			end
			if	inst.components.health.maxhealth>3000 and inst.components.health.maxhealth<=6000 then

				spawnchest(inst,8)
			end
			if	inst.components.health.maxhealth>6000 and inst.components.health.maxhealth<=10000 then

				spawnchest(inst,15)
			end
			if	inst.components.health.maxhealth>10000 and inst.components.health.maxhealth<=60000 then

				spawnchest(inst,30)
			end	
			if	inst.components.health.maxhealth>60000  then
				spawnchest(inst,40)
			end

		end
	end 
	
end
if coin_item=="skwcoin" then
	AddPrefabPostInitAny(function(inst)
		if inst.components and inst.components.health and not inst:HasTag("player") and inst.components.lootdropper then
			inst:ListenForEvent("death", death)
		end

	end)
end